# Training Notes
A place to dump some thoughts on what to actually teach.



## Basic Outline

Essentially in order but I expect this to change once we actually start working.

  * Linux
    * That old kernel, os, shell diagram - The difference between unix and linux
    * A brief history of unix
    * Unix philosophy - Do one thing, everything is a file
    * Why the ui is stupid
    * Navigating the filesystem
    * Other common commands
    * getting help - -h, man, info
    * File Operations - permissions, etc
    * Introducing VI
    * User Environment - introducing your shell, environment variables, aliases, login script
    * Processes and daemons - parent/child, environment inheritence (maybe come back to this?)
    * Basic Scripting
  * Networking
    * OSI/TCP models
    * TCP/IP
    * DNS
    * http
    * TLS
  * git
  * AWS
  * Scripting in greater depth / Programming
  * Load balancing
  * Some common services like httpd
  * Roles
    * Company roles - Enterprise, SMB, start-up
    * Org roles - Ops, Engineering, The Business
  * DevOps (Actual devops not this BS many people mean.)
  * CI/CD

# Plan

## Step 1

### Topics
  * Ye ol' circles diagram, the unix phylosophy
  * Workstation set up
  * Basic commands ls, cat
  * Basic merging in gitlab

### Tasks
  * Install some garbage on your workstation

## Step 2

### Topics
  * The filesystem
  * Navigation commands ls, cd
  * Naming syles camelCase and snake_case
  * Basic filesystem commands, cp, mv, touch, rm, mkdir, rmdir, file
  * Intro to vi

## Step 2.1

### Topics
  * SSH
  * Install Apache HTTPD
  * Create a static web page

## Step 3

### Topics
  * redirection (>, >>, |, 2>, etc.)
  * grep and an intro to regex
  * Getting help -h, man, info, google and stack overflow
  * Intro to scripting


## RHCSA

The skills notes for the RHCSA

https://www.redhat.com/en/services/training/ex200-red-hat-certified-system-administrator-rhcsa-exam?section=Objectives

and RHCE

https://www.redhat.com/en/services/training/ex300-red-hat-certified-engineer-rhce-exam-red-hat-enterprise-linux-7?section=Objectives

examms

  * Understand and use essential tools
  * Access a shell prompt and issue commands with correct syntax
  * Use input-output redirection (>, >>, |, 2>, etc.)
  * Use grep and regular expressions to analyze text
  * Access remote systems using SSH
  * Log in and switch users in multiuser targets
  * Archive, compress, unpack, and uncompress files using tar, star, gzip, and bzip2
  * Create and edit text files
  * Create, delete, copy, and move files and directories
  * List, set, and change standard ugo/rwx permissions
  * Locate, read, and use system documentation including man, info, and files in /usr/share/doc
  * Create simple shell scripts
  * Conditionally execute code (use of: if, test, [], etc.)
  * Use Looping constructs (for, etc.) to process file, command line input
  * Process script inputs ($1, $2, etc.)
  * Processing output of shell commands within a script
  * Processing shell command exit codes
  * Boot, reboot, and shut down a system normally
  * Identify CPU/memory intensive processes and kill processes
  * Locate and interpret system log files and journals
  * Securely transfer files between systems
  * Diagnose and correct file permission problems
  * Start and stop services and configure services to start automatically at boot
  * Install and update software packages from Red Hat Network, a remote repository, or from the local file system
  * Configure key-based authentication for SSH
  * Create hard and soft links
  * Adjust process scheduling
  * Work with package module streams
  * Manage users and groups
  * Create, delete, and modify local user accounts
  * Change passwords and adjust password aging for local user accounts
  * Create, delete, and modify local groups and group memberships
  * Configure superuser access
  * Manage containers
  * Find and retrieve container images from a remote registry
  * Inspect container images
  * Perform container management using commands such as podman and skopeo
  * Perform basic container management such as running, starting, stopping, and listing running containers
  * Run a service inside a container
  * Configure a container to start automatically as a systemd service
  * Attach persistent storage to a container

## Stuff for only if he wants to be a sysadmin

  * Boot systems into different targets manually
  * Interrupt the boot process in order to gain access to a system
  * Manage tuning profiles
  * Preserve system journals
  * Start, stop, and check the status of network services
  * Configure local storage
  * List, create, delete partitions on MBR and GPT disks
  * Create and remove physical volumes
  * Assign physical volumes to volume groups
  * Create and delete logical volumes
  * Configure systems to mount file systems at boot by universally unique ID (UUID) or label
  * Add new partitions and logical volumes, and swap to a system non-destructively
  * Create and configure file systems
  * Create, mount, unmount, and use vfat, ext4, and xfs file systems
  * Mount and unmount network file systems using NFS
  * Extend existing logical volumes
  * Create and configure set-GID directories for collaboration
  * Configure disk compression
  * Manage layered storage
  * Deploy, configure, and maintain systems
  * Schedule tasks using at and cron
  * Configure systems to boot into a specific target automatically
  * Configure time service clients
  * Modify the system bootloader
  * Manage basic networking
  * Configure IPv4 and IPv6 addresses
  * Configure hostname resolution
  * Configure network services to start automatically at boot
  * Restrict network access using firewall-cmd/firewall
  * Manage security
  * Configure firewall settings using firewall-cmd/firewalld
  * Create and use file access control lists
  * Set enforcing and permissive modes for SELinux
  * List and identify SELinux file and process context
  * Restore default file contexts
  * Use boolean settings to modify system SELinux settings
  * Diagnose and address routine SELinux policy violations



